#include <fstream>
#include <string>
#include <map>

const int MAX_N = 1000;
bool p[MAX_N][MAX_N];

int main()
{
	std::ifstream fin("input.txt");
	std::ofstream fout("output.txt");

	std::map<std::string, int> items;
	int N, M, K;

	fin >> N;
	for (int i = 0; i < N; ++i) {
		std::string s;
		fin >> s;
		items.insert(std::pair<std::string, int>(s, i));
	}

	for (int i = 0; i < N; ++i) {
		for (int j = 0; j < N; ++j)
			p[i][j] = false;
	}
	fin >> M;
	for (int i = 0; i < M; ++i) {
		std::string x, y;
		fin >> x >> y;
		int xn = items.find(x)->second;
		int yn = items.find(y)->second;
		p[xn][yn] = true;
	}

	fin >> K;
	for (int i = 0; i < K; ++i) {
		std::string x, y;
		fin >> x >> y;
		int xn = items.find(x)->second;
		int yn = items.find(y)->second;
		int r = 0;
		if (p[xn][yn])
			r = 1;
		else if (p[yn][xn])
			r = 2;
		fout << r << " ";
	}

	return 0;
}