{$APPTYPE CONSOLE}

program kam;
const
  MAX_STRING_LENGTH = 20;
  MAX_N = 1000;
  MAX_M = 20000;
  MAX_K = 20000;
var
  a: array[1..MAX_N] of string;
  p: array[1..MAX_N,1..MAX_N] of boolean;
  n,m,k: integer;
  x,y: string;
  xn,yn: integer;
  r: integer;
  fin,fout: text;
  i,j: integer;

  procedure swap_str(var a,b: string);
  var
    tmp: string;
  begin
    tmp := a;
    a := b;
    b := tmp;
  end;
  
  procedure sort_items;

    function partition(l,r: integer): integer;
    var
      x: string;
      i,j: integer;
    begin
      x := a[l];
      i := l-1;
      j := r+1;
      while true do
      begin
        repeat
          dec(j);
        until (a[j] <= x);
        repeat
          inc(i);
        until (a[i] >= x);
        if (i < j) then
          swap_str(a[i],a[j])
        else
        begin
          Result := j;
          break;
        end;
      end;
    end;

    procedure quick_sort(l,r: integer);
    var
      q: integer;
    begin
      if (l < r) then
      begin
        q := partition(l,r);
        quick_sort(l,q);
        quick_sort(q+1,r);
      end;
    end;

  begin
    quick_sort(1,n);
  end;

  function find_item(s: string): integer;
  var
    l,r,q: integer;
  begin
    Result := 0;
    l := 1;
    r := n;
    while (l <= r) do
    begin
      q := (l+r) div 2;
      if (a[q] = s) then
      begin
        Result := q;
        break;
      end
      else if (a[q] < s) then
        l := q+1
      else
        r := q-1;
    end;
  end;

begin
  assign(fin,'input.txt');
  reset(fin);
  assign(fout,'output.txt');
  rewrite(fout);

  readln(fin,n);
  assert((n >= 2) and (n <= MAX_N));
  for i := 1 to n do
  begin
    readln(fin,a[i]);
    {   :
       -    1  20 ;
       -      . }
    if (not ((length(a[i]) >= 1) and (length(a[i]) <= MAX_STRING_LENGTH))) then
      halt(1);
    for j := 1 to length(a[i]) do
    begin
      if (not (a[i][j] in ['a'..'z'])) then
        halt(1);
    end;
  end;
  sort_items;
  {   :
     -   . }
  for i := 1 to n-1 do
  begin
    if (a[i] = a[i+1]) then
      halt(1);
  end;

  for i := 1 to n do
  begin
    for j := 1 to n do
      p[i,j] := false;
  end;
  readln(fin,m);
  assert((m >= 1) and (m <= MAX_M));
  for i := 1 to m do
  begin
    readln(fin,x);
    readln(fin,y);
    xn := find_item(x);
    if (xn = 0) then
      halt(1);
    yn := find_item(y);
    if (yn = 0) then
      halt(1);
    {   :
       -     ;
       -          . }
    if (xn = yn) then
      halt(1);
    if (p[xn,yn] or p[yn,xn]) then
      halt(1);
    p[xn,yn] := true;
  end;

  readln(fin,k);
  assert((k >= 1) and (k <= MAX_K));
  for i := 1 to k do
  begin
    readln(fin,x);
    readln(fin,y);
    xn := find_item(x);
    if (xn = 0) then
      halt(1);
    yn := find_item(y);
    if (yn = 0) then
      halt(1);
    if (p[xn,yn]) then
      r := 1
    else if (p[yn,xn]) then
      r := 2
    else
      r := 0;
    write(fout,r,' ');
  end;

  if (not Eof(fin)) then
    halt(1);

  close(fin);
  close(fout);
end.
